import com.exalate.basic.domain.hubobject.v1.BasicHubIssue

class UpdateIssue {
    private static def log = org.slf4j.LoggerFactory.getLogger("com.exalate.scripts.UpdateIssue")

    private static def doUpdate = { @javax.annotation.Nonnull BasicHubIssue replica,
                                    @javax.annotation.Nonnull BasicHubIssue issue,
                                    @javax.annotation.Nonnull com.exalate.api.domain.connection.IConnection relation,
                                    @javax.annotation.Nonnull com.exalate.node.hubobject.v1_3.NodeHelper nodeHelper,
                                    @javax.annotation.Nonnull BasicHubIssue issueBeforeScript,
                                    @javax.annotation.Nonnull List<com.exalate.api.domain.twintrace.INonPersistentTrace> traces,
                                    @javax.annotation.Nonnull List<com.exalate.api.domain.IBlobMetadata> blobMetadataList,
                                    @javax.annotation.Nonnull com.atlassian.jira.issue.MutableIssue jIssue,
                                    @javax.annotation.Nonnull com.exalate.basic.domain.BasicIssueKey exIssueKey ->
        try {
            final def hohfInternal2 = com.atlassian.jira.component.ComponentAccessor.getOSGiComponentInstanceOfType(com.exalate.api.hubobject.IHubObjectHelperFactory.class)
            //noinspection GroovyAssignabilityCheck
            final def hohInternal2 = hohfInternal2.get("1.2.0")
            final def nservInternal2 = com.atlassian.jira.component.ComponentAccessor.getOSGiComponentInstanceOfType(com.exalate.api.node.INodeService.class)

            def proxyAppUserInternal2 = nservInternal2.getProxyUser()

            log.info("performing the update for the issue `" + jIssue.key + "` for remote issue `" + replica.key + "`")
            //finally create all
            def fakeTraces2 = com.exalate.util.TraceUtils.indexFakeTraces(traces)
            def preparedIssue2 = hohInternal2.prepareLocalHubIssueForApplication(issueBeforeScript, issue, fakeTraces2)
            //@Nonnull IIssueKey issueKey, @Nonnull IHubIssueReplica hubIssueAfterScripts, @Nullable String proxyUser, @Nonnull IHubIssueReplica hubIssueBeforeScripts, @Nonnull Map<TraceType, List<ITrace>> traces, @Nonnull List<IBlobMetadata> blobMetadataList, IRelation relation
            def resultTraces2 = hohInternal2.updateNodeIssueWith(exIssueKey, preparedIssue2, proxyAppUserInternal2.key, issueBeforeScript, fakeTraces2, blobMetadataList, relation)
            traces.clear()
            traces.addAll(resultTraces2 ?: [])
            new Result(issue, traces)
        } catch (com.exalate.api.exception.IssueTrackerException ite2) {
            throw ite2
        } catch (Exception e2) {
            throw new com.exalate.api.exception.IssueTrackerException(e2.message, e2)
        }
    }

    static Result update(@javax.annotation.Nonnull BasicHubIssue replica,
                                @javax.annotation.Nonnull BasicHubIssue issue,
                                @javax.annotation.Nonnull com.exalate.api.domain.connection.IConnection relation,
                                @javax.annotation.Nonnull com.exalate.node.hubobject.v1_3.NodeHelper nodeHelper,
                                @javax.annotation.Nonnull BasicHubIssue issueBeforeScript,
                                @javax.annotation.Nonnull List<com.exalate.api.domain.twintrace.INonPersistentTrace> traces,
                                @javax.annotation.Nonnull List<com.exalate.api.domain.IBlobMetadata> blobMetadataList,
                                @javax.annotation.Nonnull com.exalate.basic.domain.BasicIssueKey exIssueKey) {
        def im = com.atlassian.jira.component.ComponentAccessor.issueManager
        def jIssue = im.getIssueObject(issue.id as Long)
        doUpdate(replica, issue, relation, nodeHelper, issueBeforeScript, traces, blobMetadataList, jIssue, exIssueKey)
    }

    static Result update(@javax.annotation.Nonnull BasicHubIssue replica,
                                @javax.annotation.Nonnull BasicHubIssue issue,
                                @javax.annotation.Nonnull com.exalate.api.domain.connection.IConnection relation,
                                @javax.annotation.Nonnull com.exalate.node.hubobject.v1_3.NodeHelper nodeHelper,
                                @javax.annotation.Nonnull BasicHubIssue issueBeforeScript,
                                @javax.annotation.Nonnull List<com.exalate.api.domain.twintrace.INonPersistentTrace> traces,
                                @javax.annotation.Nonnull List<com.exalate.api.domain.IBlobMetadata> blobMetadataList,
                                @javax.annotation.Nonnull com.atlassian.jira.issue.MutableIssue jIssue,
                                @javax.annotation.Nonnull com.exalate.basic.domain.BasicIssueKey exIssueKey) {
        doUpdate(replica, issue, relation, nodeHelper, issueBeforeScript, traces, blobMetadataList, jIssue, exIssueKey)
    }

    static class Result {
        BasicHubIssue issue
        List<com.exalate.api.domain.twintrace.INonPersistentTrace> traces

        Result(BasicHubIssue issue, java.util.List<com.exalate.api.domain.twintrace.INonPersistentTrace> traces) {
            this.issue = issue
            this.traces = traces
        }
    }
}